//=========================================================================
//
//   gxx_gradcomp.c
//
//   USGS_Gradcomp FORTRAN method wrapper.
//
//=========================================================================

#define C_MICROSOFT

// The following include files define Geosoft constants
//  and library functions prototypes

#include <gx_define.h>
#include <gx_lib.h>
#include <gx_extern.h>

// The following include file contains the prototype for the "gradcomp" routine,
// as well as the definition of the global structure.

#include "wrappers.h"


//---------------------------------------------------------------------------

GX_WRAPPER_FUNC GX_LONG GX_WRAPPER_CALL
IUSGS_Gradcomp(void       *pGeo,
              const char *pcInfile,
              long       *plInfile_len,
              const char *pcOutfilh,
              long       *plOutfilh_len,
              const char *pcOutfilx,
              long       *plOutfilx_len,
              const char *pcOutfily,
              long       *plOutfily_len,
              long       *plWin,
              long       *plPoly)
{         
   const char *modn = "IUSGS_Gradcomp";
   
//   long lWin,lPoly;
   long lErr=0;

   // --- Load the global structure ---

   InitGlobals(pGeo);

   // --- Convert doubles to floats for REAL*4 ---

//   fMult = (float)*pdMult;

   // --- Process the grid ---

   gradcomp_((char *)pcInfile, (char *)pcOutfilh, (char *)pcOutfilx,
                            (char *)pcOutfily, plWin, plPoly, &lErr,
                            *plInfile_len, *plOutfilh_len,
                            *plOutfilx_len, *plOutfily_len);


   return 0;
}


