c
      subroutine gridmask(infile1,infile2,outfile,inorm,ierr)
c
c infile1 - input grid file to be masked
c infile2 - input grid file containing the dummy values
c outfile  - output masked grid file
c inorm  - 1 = normal masking
c          0 = inverse masking
c ierr   - 0 for no error
c          1 for error
c
      parameter (maxcol=16384)
c
      character*(*) infile1,infile2,outfile
      real*4 dummy
      real*4 g1(maxcol),g2(maxcol)
      integer*4 inorm,ierr,inunit1,inunit2,outunit
      data dummy/-1.0e32/
      data inunit1/0/,inunit2/0/,outunit/0/
c
c  Open the grid to be masked
c
      call OpenGrid_WF(infile1,inunit1,ierr)
      if(ierr.eq.1) goto 9999
c
      call GetGridInfo_WF(inunit1,nc,nr,xo,yo,dx,dy,rot,ierr)
      if(ierr.eq.1) goto 9999
c
c  Check grid dimensions and register an error if it is too big to handle
c
      if(nc.gt.maxcol) then
         call RegisterErr_WF(3000,'usgs')
         call SetErrParmI_WF(1,nc)
         call SetErrParmI_WF(2,maxcol)
         ierr = 1
         goto 9999
      endif
c
c  Open the masking grid
c
      call OpenGrid_WF(infile2,inunit2,ierr)
      if(ierr.eq.1) goto 9999

      call GetGridInfo_WF(inunit2,nc1,nr1,xo1,yo1,dx1,dy1,rot1,ierr)
      if(ierr.eq.1) goto 9999
c
c  Check grid dimensions and register an error if it is too big to handle
c
      if(nc1.gt.maxcol) then
         call RegisterErr_WF(3000,'usgs')
         call SetErrParmI_WF(1,nc1)
         call SetErrParmI_WF(2,maxcol)
         ierr = 1
         goto 9999
      endif
      if(dx1.ne.dx.or.dy1.ne.dy) then
         call RegisterErr_WF(3003,'usgs')
         ierr = 1
         go to 9999
      endif
c
c  Open the output grid. Supply the grid name and size.
c
      call NewGrid_WF(outunit,outfile,nc1,nr1,xo1,yo1,dx,dy, 
     &                rot, ierr)
      if(ierr.eq.1) goto 9999
c
      ymax=yo1+(nr1-1)*dy
      xmax=xo1+(nc1-1)*dx
      j1=0
      i0=0

      do 2000 j=1,nr
      y=yo+(j-1)*dy
      if(y.lt.yo1) go to 2000
      j1=j1+1
      if(y.gt.ymax) go to 3000
      call GetRow_WF(inunit1,j,nc,g1,ierr)
      call GetRow_WF(inunit2,j1,nc1,g2,ierr)
      i1=0
      do 1000 i=1,nc
      x=xo+(i-1)*dx
      if(x.lt.xo1) go to 1000
      if(i0.eq.0) i0=i
      i1=i1+1
      if(x.gt.xmax) go to 1500
      if(inorm.eq.1) then
        if(g2(i1).eq.dummy) g1(i)=dummy
      else
        if(g2(i1).ne.dummy) g1(i)=dummy
      endif
 1000 continue
 1500 call PutRow_WF(outunit,j1,nc1,g1(i0),ierr)
 2000 continue
 3000 continue
c      
9999  continue 
c
      if(inunit1.ne.0) then
         call CloseGrid_WF(inunit1, ierr)
      endif
c
      if(inunit2.ne.0) then
         call CloseGrid_WF(inunit2, ierr)
      endif      
c
      if(outunit.ne.0) then
         call CloseGrid_WF(outunit, ierr)
      endif
c
      return
      end
