      subroutine gridplug(ifile,ofile,iorder,niter,ierr)
C
C     PROGRAM TO FILL UP NO DATA VALUES IN A GRID WITH
C     INTERPOLATED VALUES USING MINIMUM CURVATURE.
C
      parameter (maxcol=10000)
      common /size/ nc,nr,ncm1,ncm2,dx,dy
      common /array/ jrow(maxcol),work(maxcol),work1(maxcol)
      character*(*) ifile,ofile
      data dummy/-1.e32/
      data iunit/0/,iounit/0/,isunit/0/,iosunit/0/
c
      call OpenGrid_WF(ifile,iunit,ierr)
      if(ierr.eq.1) goto 9999
      call GetGridInfo_WF(iunit,nc,nr,xo,yo,dx,dy,rot,ierr)
      if(ierr.eq.1) goto 9999
      if(nc.gt.maxcol) then
         call RegisterErr_WF(4000,'usgs')
         call SetErrParmI_WF(1,nc)
         call SetErrParmI_WF(2,maxcol)
         ierr = 1
         goto 9999
      endif
c
      ncm1=nc-1
      ncm2=nc-2
C
      call NewGrid_WF(iounit,ofile,nc,nr,xo,yo,dx,dy,rot,ierr)
      if(ierr.eq.1) goto 9999
c
c      call NewGrid_WF(isunit,'gridplug.scr(USG,Type=PC)',nc,nr,xo,yo,dx,
c     1dy,rot,ierr)
      call NewGrid_WF(isunit,'gridplug.scr',nc,nr,xo,yo,dx,dy,rot,ierr)
      if(ierr.eq.1) goto 9999
C
c      call NewGrid_WF(iosunit,'gridplu1.scr(USG,Type=PC)',nc,nr,xo,yo,
c     1dx,dy,rot,ierr)
      call NewGrid_WF(iosunit,'gridplu1.scr',nc,nr,xo,yo,dx,dy,rot,ierr)
      
      if(ierr.eq.1) goto 9999
c      
      call ProgName_WF('Gridplug: Step 1 of 3 - Filling Work Arrays',1)
      call ProgUpdate_WF(0)
      ICOUNT=0
      DO 20 J=1,NR
      call GetRow_WF(iunit,j,nc,work,ierr)
      if(ierr.eq.1) goto 9999
      IND=0
      DO 10 I=1,NC
      IF (WORK(I).eq.dummy) THEN
        IND=IND+1
        WORK1(I)=1.
      else
        WORK1(I)=0.
      ENDIF
   10 CONTINUE
      IF (IND.GT.0) THEN
        ICOUNT=ICOUNT+1
        if(icount.gt.maxcol) then
          call RegisterErr_WF(4001,'usgs')
          ierr=1
          goto 9999
        endif
        JROW(ICOUNT)=J
      ENDIF
      call PutRow_WF(iounit,j,nc,work,ierr)
      call PutRow_WF(isunit,j,nc,work1,ierr)
      if(ierr.eq.1) goto 9999
      call ProgUpdateL_WF(j,NR)
      call CheckStop_WF(ierr)
            if(ierr.eq.1) goto 9999
   20 CONTINUE

      call CloseGrid_WF(iounit, ierr)
      call OpenGrid_WF(ofile,iounit,ierr)

      call CloseGrid_WF(isunit, ierr)
      call OpenGrid_WF('gridplug.scr',isunit,ierr)
            
      call ProgUpdate_WF(100)
      call ProgName_WF('Gridplug: Step 2 of 3 - Polynomial or Median Fil
     1l',1)
      call ProgUpdate_WF(0)      
      if(iorder.eq.-1) then
c Initializing using median replacement:
        call MEDIPLUG(iounit,iosunit,ofile,'gridplu1.scr',ierr)
      else if(iorder.eq.0) then
c      if(iorder.eq.0) then
c Initializing using average value:
        call POLYPLUG(iounit,0,ierr)
      else if(iorder.eq.1) then
c Initializing using planar surface:
        call POLYPLUG(iounit,1,ierr)
      else if(iorder.eq.2) then
c Initializing using quadratic surface:
        call POLYPLUG(iounit,2,ierr)
      else if(iorder.eq.3) then
c Initializing using cubic surface:
        call POLYPLUG(iounit,3,ierr)
      endif
      if(ierr.ne.0) go to 9999
      call ProgUpdate_WF(100)

c      call CloseGrid_WF(iounit, ierr)
c      call OpenGrid_WF(ofile,iounit,ierr)
      
c Performing minimum curvature iterations:
C
C     READ DATA AND ITERATE FOR POINTS WITH ZNIL'S
C
      IF (ICOUNT.EQ.0) then
c         Grid does not require plugging
          call RegisterErr_WF(4002,'usgs')
          ierr=1
          goto 9999
        endif
c
      if(niter.lt.1) go to 1000
      call ProgName_WF('Gridplug: Step 3 of 3 - Minimum Curvature Iterat
     1ions',1)
      call ProgUpdate_WF(0)
            
      DO 30 N=1,NITER
      CALL GRIDPLG2 (iounit,isunit)
      call ProgUpdateL_WF(N,NITER)
      call CheckStop_WF(ierr)
            if(ierr.eq.1) goto 9999
            
c      call CloseGrid_WF(iounit, ierr)
c      call OpenGrid_WF(ofile,iounit,ierr)
            
   30 CONTINUE
      call ProgUpdate_WF(100)
1000  continue
9999  continue
c
      if(iunit.ne.0) then
         call CloseGrid_WF(iunit, ierr)
      endif
c
      if(iounit.ne.0) then
         call CloseGrid_WF(iounit, ierr)
      endif
c
      if(isunit.ne.0) then
         call CloseGrid_WF(isunit, ierr)
      endif
c
      if(iosunit.ne.0) then
         call CloseGrid_WF(iosunit, ierr)
      endif
c      
      return
      END
C
      SUBROUTINE GRIDPLG2 (IFLB,IFLD)
C ********************************************************************
C
C     GRIDPLG2 PERFORMS A MINIMUM CURVATURE ITERATION ON
C     DATA WHICH WERE PREVIOUSLY NULL VALUES.
C
C ********************************************************************
C
      parameter (maxcol=10000)
      common /size/ nc,nr,ncm1,ncm2,dx,dy
      common /array/ jrow(maxcol),work(maxcol),work1(maxcol)
      dimension dt(maxcol,5)
C
C     READ GRID DATA
C
      DO 10 J=1,5
c      read(iflb,rec=j) (dt(i,j),i=1,nc)
      call GetRow_WF(iflb,j,nc,dt(1,j),ierr)
   10 CONTINUE
      ind=1
      j=0
C
C     PROCESS FIRST ROW
C
   20 if(jrow(ind).ne.1) go to 40
      ind=ind+1
c      read(ifld,rec=1) (work(i),i=1,nc)
      call GetRow_WF(ifld,1,nc,work,ierr)      
      J=1
      JP1=J+1
      JP2=J+2
      IF (WORK(1).GT.0.5) THEN
        I=1
        TERM1=DT(I+2,J)+DT(I,JP2)
        TERM2=DT(I+1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1+2.*TERM2)/2.
      ENDIF
      IF (WORK(2).GT.0.5) THEN
        I=2
        TERM1=DT(I+2,J)+DT(I+1,JP1)+DT(I,JP2)+DT(I-1,JP1)
        TERM2=DT(I-1,J)
        TERM4=DT(I+1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1+2.*TERM2+4.*TERM4)/6.
      ENDIF
C
      DO 30 I=3,NCM2
      IF (WORK(I).GT.0.5) THEN
        TERM1=DT(I+2,J)+DT(I+1,JP1)+DT(I,JP2)+DT(I-1,JP1)+DT(I-2,J)
        TERM4=DT(I+1,J)+DT(I,JP1)+DT(I-1,J)
        DT(I,J)=(-TERM1+4.*TERM4)/7.
      ENDIF
   30 CONTINUE
C
      IF (WORK(NCM1).GT.0.5) THEN
        I=NCM1
        TERM1=DT(I-2,J)+DT(I-1,JP1)+DT(I,JP2)+DT(I+1,JP1)
        TERM2=DT(I+1,J)
        TERM4=DT(I-1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1+2.*TERM2+4.*TERM4)/6.
      ENDIF
      IF (WORK(NC).GT.0.5) THEN
        I=NC
        TERM1=DT(I-2,J)+DT(I,JP2)
        TERM2=DT(I-1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1+2.*TERM2)/2.
      ENDIF
c      write(iflb,rec=1) (dt(i,1),i=1,nc)
      call PutRow_WF(iflb,1,nc,dt(1,1),ierr)
C
C     PROCESS SECOND ROW
C
   40 if(jrow(ind).ne.2) go to 60
      ind=ind+1
c      read(ifld,rec=2) (work(i),i=1,nc)
      call GetRow_WF(ifld,2,nc,work,ierr)
      J=2
      JP1=J+1
      JP2=J+2
      JM1=J-1
      IF (WORK(1).GT.0.5) THEN
        I=1
        TERM1=DT(I+1,JM1)+DT(I+2,J)+DT(I+1,JP1)+DT(I,JP2)
        TERM2=DT(I,JM1)
        TERM4=DT(I+1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1+2.*TERM2+4.*TERM4)/6.
      ENDIF
      IF (WORK(2).GT.0.5) THEN
        I=2
        TERM1=DT(I+2,J)+DT(I,JP2)+DT(I+1,JM1)+DT(I-1,JP1)
        TERM2=DT(I+1,JP1)
        TERM4=DT(I-1,J)+DT(I,JM1)
        TERM8=DT(I+1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1-2.*TERM2+4.*TERM4+8.*TERM8)/18.
      ENDIF
C
      DO 50 I=3,NCM2
      IF (WORK(I).GT.0.5) THEN
        TERM1=DT(I-1,JM1)+DT(I+1,JM1)+DT(I-2,J)+DT(I+2,J)+DT(I,JP2)
        TERM2=DT(I+1,JP1)+DT(I-1,JP1)
        TERM4=DT(I,JM1)
        TERM8=DT(I+1,J)+DT(I-1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1-2.*TERM2+4.*TERM4+8.*TERM8)/19.
      ENDIF
   50 CONTINUE
C
      IF (WORK(NCM1).GT.0.5) THEN
        I=NCM1
        TERM1=DT(I-2,J)+DT(I,JP2)+DT(I+1,JP1)+DT(I-1,JM1)
        TERM2=DT(I-1,JP1)
        TERM4=DT(I+1,J)+DT(I,JM1)
        TERM8=DT(I-1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1-2.*TERM2+4.*TERM4+8.*TERM8)/18.
      ENDIF
      IF (WORK(NC).GT.0.5) THEN
        I=NC
        TERM1=DT(I-2,J)+DT(I-1,JP1)+DT(I-1,JM1)+DT(I,JP2)
        TERM2=DT(I,JM1)
        TERM4=DT(I,JP1)+DT(I-1,J)
        DT(I,J)=(-TERM1+2.*TERM2+4.*TERM4)/6.
      ENDIF
c      write(iflb,rec=2) (dt(i,2),i=1,nc)
      call PutRow_WF(iflb,2,nc,dt(1,2),ierr)
C
C     PROCESS ROWS 3 THROUGH NR-2
C
   60 continue
      J=3
      JP1=J+1
      JP2=J+2
      JM1=J-1
      JM2=J-2
      do 75 k=3,nr-2
      if(jrow(ind).ne.k) go to 72
      ind=ind+1
c      read(ifld,rec=k) (work(i),i=1,nc)
      call GetRow_WF(ifld,k,nc,work,ierr)
      IF (WORK(1).GT.0.5) THEN
        I=1
        TERM1=DT(I,JM2)+DT(I+1,JM1)+DT(I+2,J)+DT(I+1,JP1)+DT(I,JP2)
        TERM4=DT(I,JM1)+DT(I+1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1+4.*TERM4)/7.
      ENDIF
      IF (WORK(2).GT.0.5) THEN
        I=2
        TERM1=DT(I,JM2)+DT(I-1,JM1)+DT(I+2,J)+DT(I-1,JP1)+DT(I,JP2)
        TERM2=DT(I+1,JM1)+DT(I+1,JP1)
        TERM4=DT(I-1,J)
        TERM8=DT(I,JM1)+DT(I+1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1-2.*TERM2+4.*TERM4+8.*TERM8)/19.
      ENDIF
C
      DO 70 I=3,NCM2
      IF (WORK(I).GT.0.5) THEN
        TERM1=DT(I,JM2)+DT(I+2,J)+DT(I-2,J)+DT(I,JP2)
        TERM2=DT(I-1,JM1)+DT(I+1,JM1)+DT(I-1,JP1)+DT(I+1,JP1)
        TERM8=DT(I,JM1)+DT(I-1,J)+DT(I+1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1-2.*TERM2+8.*TERM8)/20.
      ENDIF
   70 CONTINUE
C
      IF (WORK(NCM1).GT.0.5) THEN
        I=NCM1
        TERM1=DT(I,JM2)+DT(I+1,JM1)+DT(I-2,J)+DT(I+1,JP1)+DT(I,JP2)
        TERM2=DT(I-1,JM1)+DT(I-1,JP1)
        TERM4=DT(I+1,J)
        TERM8=DT(I,JM1)+DT(I-1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1-2.*TERM2+4.*TERM4+8.*TERM8)/19.
      ENDIF
      IF (WORK(NC).GT.0.5) THEN
        I=NC
        TERM1=DT(I,JM2)+DT(I-1,JM1)+DT(I-2,J)+DT(I-1,JP1)+DT(I,JP2)
        TERM4=DT(I,JM1)+DT(I-1,J)+DT(I,JP1)
        DT(I,J)=(-TERM1+4.*TERM4)/7.
      ENDIF
c      write(iflb,rec=k) (dt(i,3),i=1,nc)
      call PutRow_WF(iflb,k,nc,dt(1,3),ierr)
   72 continue
      if(k.eq.nr-2) go to 75
      do 74 jk=1,4
      do 74 i=1,nc
      dt(i,jk)=dt(i,jk+1)
   74 continue
c      read(iflb,rec=k+3) (dt(i,5),i=1,nc)
      call GetRow_WF(iflb,k+3,nc,dt(1,5),ierr)
   75 continue
C
C     PROCESS ROW NR-1
C
   80 k=nr-1
      if(jrow(ind).ne.k) go to 100
      J=4
      JP1=J+1
      JM1=J-1
      JM2=J-2
      ind=ind+1
c      read(ifld,rec=k) (work(i),i=1,nc)
      call GetRow_WF(ifld,k,nc,work,ierr)
      IF (WORK(1).GT.0.5) THEN
        I=1
        TERM1=DT(I+1,JP1)+DT(I+2,J)+DT(I+1,JM1)+DT(I,JM2)
        TERM2=DT(I,JP1)
        TERM4=DT(I+1,J)+DT(I,JM1)
        DT(I,J)=(-TERM1+2.*TERM2+4.*TERM4)/6.
      ENDIF
      IF (WORK(2).GT.0.5) THEN
        I=2
        TERM1=DT(I+2,J)+DT(I,JM2)+DT(I+1,JP1)+DT(I-1,JM1)
        TERM2=DT(I+1,JM1)
        TERM4=DT(I-1,J)+DT(I,JP1)
        TERM8=DT(I+1,J)+DT(I,JM1)
        DT(I,J)=(-TERM1-2.*TERM2+4.*TERM4+8.*TERM8)/18.
      ENDIF
C
      DO 90 I=3,NCM2
      IF (WORK(I).GT.0.5) THEN
        TERM1=DT(I-1,JP1)+DT(I+1,JP1)+DT(I-2,J)+DT(I+2,J)+DT(I,JM2)
        TERM2=DT(I+1,JM1)+DT(I-1,JM1)
        TERM4=DT(I,JP1)
        TERM8=DT(I+1,J)+DT(I-1,J)+DT(I,JM1)
        DT(I,J)=(-TERM1-2.*TERM2+4.*TERM4+8.*TERM8)/19.
      ENDIF
   90 CONTINUE
C
      IF (WORK(NCM1).GT.0.5) THEN
        I=NCM1
        TERM1=DT(I-2,J)+DT(I,JM2)+DT(I+1,JM1)+DT(I-1,JP1)
        TERM2=DT(I-1,JM1)
        TERM4=DT(I+1,J)+DT(I,JP1)
        TERM8=DT(I-1,J)+DT(I,JM1)
        DT(I,J)=(-TERM1-2.*TERM2+4.*TERM4+8.*TERM8)/18.
      ENDIF
      IF (WORK(NC).GT.0.5) THEN
        I=NC
        TERM1=DT(I-2,J)+DT(I-1,JM1)+DT(I-1,JP1)+DT(I,JM2)
        TERM2=DT(I,JP1)
        TERM4=DT(I,JM1)+DT(I-1,J)
        DT(I,J)=(-TERM1+2.*TERM2+4.*TERM4)/6.
      ENDIF
c      write(iflb,rec=k) (dt(i,4),i=1,nc)
      call PutRow_WF(iflb,k,nc,dt(1,4),ierr)
C
C     PROCESS ROW NR
C
  100 continue
      k=nr
      if(jrow(ind).ne.k) go to 120
c      read(ifld,rec=k) (work(i),i=1,nc)
      call GetRow_WF(ifld,k,nc,work,ierr)
      J=5
      JM1=J-1
      JM2=J-2
      ind=ind+1
      IF (WORK(1).GT.0.5) THEN
        I=1
        TERM1=DT(I+2,J)+DT(I,JM2)
        TERM2=DT(I+1,J)+DT(I,JM1)
        DT(I,J)=(-TERM1+2.*TERM2)/2.
      ENDIF
      IF (WORK(2).GT.0.5) THEN
        I=2
        TERM1=DT(I+2,J)+DT(I+1,JM1)+DT(I,JM2)+DT(I-1,JM1)
        TERM2=DT(I-1,J)
        TERM4=DT(I+1,J)+DT(I,JM1)
        DT(I,J)=(-TERM1+2.*TERM2+4.*TERM4)/6.
      ENDIF
C
      DO 110 I=3,NCM2
        IF (WORK(I).GT.0.5) THEN
        TERM1=DT(I+2,J)+DT(I+1,JM1)+DT(I,JM2)+DT(I-1,JM1)+DT(I-2,J)
        TERM4=DT(I+1,J)+DT(I,JM1)+DT(I-1,J)
        DT(I,J)=(-TERM1+4.*TERM4)/7.
      ENDIF
  110 CONTINUE
C
      IF (WORK(NCM1).GT.0.5) THEN
        I=NCM1
        TERM1=DT(I-2,J)+DT(I-1,JM1)+DT(I,JM2)+DT(I+1,JM1)
        TERM2=DT(I+1,J)
        TERM4=DT(I-1,J)+DT(I,JM1)
        DT(I,J)=(-TERM1+2.*TERM2+4.*TERM4)/6.
      ENDIF
      IF (WORK(NC).GT.0.5) THEN
        I=NC
        TERM1=DT(I-2,J)+DT(I,JM2)
        TERM2=DT(I-1,J)+DT(I,JM1)
        DT(I,J)=(-TERM1+2.*TERM2)/2.
      ENDIF
c      write(iflb,rec=k) (dt(i,5),i=1,nc)
      call PutRow_WF(iflb,k,nc,dt(1,5),ierr)
C
  120 continue
C
      RETURN
      END
C      subroutine mediplug(in1,io1,file1,file2,ierr)
      subroutine mediplug(in,io,file1,file2,ierr)
      parameter (maxcol=10000)
      character*(*) file1,file2
C      character*128 tfile
c      common /stats/ zmin,zmax,zavrg
      common /size/ nc,nr,ncm1,ncm2,dx,dy
      common /array/ jrow(maxcol),a(maxcol),c(maxcol)
      dimension b(maxcol,3)
      data dummy / -1.0e+32 /
      ierr=0
C      in=in1
C      io=io1
C      ndold=9999
      ndold=nc*nr
      iter=0
9     continue
c      read(in,rec=1) (b(i,3),i = 1, nc)
c      read(in,rec=2) (b(i,2),i = 1, nc)
      call GetRow_WF(in,1,nc,b(1,3),ierr)
      call GetRow_WF(in,2,nc,b(1,2),ierr)
      nd = 0
c      if(ndold.eq.9999) ndold=nc*nr
      do 20 i=1,nc
      if(b(i,3).eq.dummy) b(i,3)=b(i,2)
      if(b(i,3).eq.dummy) nd = nd + 1
   20 continue
c      write(io,rec=1) (b(i,3),i = 1, nc)
      call PutRow_WF(io,1,nc,b(1,3),ierr)
      do 14 ii = 3, nr
c        read(in,rec=ii) (b(i,1),i = 1, nc)
      call GetRow_WF(in,ii,nc,b(1,1),ierr)
        c(1) = b(1,2)
        if(c(1).eq.dummy) c(1)=b(2,2)
        c(nc) = b(nc,2)
        if(c(nc).eq.dummy) c(nc)=b(nc-1,2)
        do 12 i = 2, nc - 1
          c(i) = b(i,2)
          if (c(i) .eq. dummy) then
            j = 0
            do 11 k = 1, 3
              do 10 l = i - 1, i + 1
                if (b(l,k) .ne. dummy) then
                  j = j + 1
                  a(j) = b(l,k)
                end if
10            continue
11          continue
            if (j .gt. 1) call median(j, a)
            if (j .ge. 1) c(i) = a(1)
          end if
12      continue
        do 22 i=1,nc
22      if(c(i).eq.dummy) nd = nd + 1
c        write(io,rec=ii-1) (c(i),i = 1, nc)
        call PutRow_WF(io,ii-1,nc,c,ierr)
        do 13 i = 1, nc
          b(i,3) = b(i,2)
          b(i,2) = b(i,1)
13      continue
14    continue
      do 21 i=1,nc
      if(b(i,1).eq.dummy) b(i,1)=b(i,3)
      if(b(i,1).eq.dummy) nd = nd + 1
   21 continue
c      write(io,rec=nr) (b(i,1),i = 1, nc)
      call PutRow_WF(io,nr,nc,b(1,1),ierr)
c      write(*, 101) nd,ndold
c  101 format(1h+,i10,13h dvals remain)
      if(ndold.eq.nc*nr) nd1=nd
      call ProgUpdateL_WF(nd1-nd,nd1)
      call CheckStop_WF(ierr)
            if(ierr.eq.1) goto 9999
      call CloseGrid_WF(in, ierr)
      call CloseGrid_WF(io, ierr)
      if(MOD(iter,2).eq.0) then
            call OpenGrid_WF(file1,in,ierr)
            call OpenGrid_WF(file2,io,ierr)
      else
            call OpenGrid_WF(file2,in,ierr)
            call OpenGrid_WF(file1,io,ierr)
      endif
      iter=iter+1
C      io1=io
      if(nd.lt.ndold) then
        ndold=nd
        it=in
        in=io
        io=it
C        tfile=file1
C        file1=file2
C        file2=tfile
        go to 9
      endif
      if(in1.eq.in) go to 9999
      
      do 8 j=1,nr
c      read(in,rec=j) (b(i,3),i = 1, nc)
      call GetRow_WF(in,j,nc,b(1,3),ierr)
c      write(io,rec=j) (b(i,3),i = 1, nc)
      call PutRow_WF(io,j,nc,b(1,3),ierr)
    8 continue
 9999 return
      end
c
      subroutine median(n, a)
      dimension a(n)
   10 if (n .lt. 2) return
      if(n.eq.2) then
       a(1)=(a(1)+a(2))/2.
       return
      endif
      ax = a(1)
      an = a(1)
      iax = 1
      ian = 1
      do 11 i = 2, n
        if (a(i) .gt. ax) then
          ax = a(i)
          iax = i
        end if
        if (a(i) .lt. an) then
          an = a(i)
          ian = i
        end if
11    continue
      if (an .eq. ax) then
        a(1) = an
        return
      end if
      j = 0
      do 20 i = 1, n
      temp = a(i)
      if ((i .eq. iax) .or. (i .eq. ian)) goto 20
      j = j + 1
      a(j) = temp
   20 continue
      n = j
      goto 10
      end
c
      subroutine polyplug(in1,iorder,ierr)
      parameter (maxcol=10000)
c      common /stats/ zmin,zmax,zavrg
      common /size/ nc,nr,ncm1,ncm2,dx,dy
      common /array/ jrow(maxcol),z(maxcol),u(maxcol)
      dimension a(maxcol/4,10),b(maxcol/2)
c     1               u(maxcol),dum(maxcol)
      dimension c(10)
c      character*6 label(10)
      data dummy /-1.0e32/
c      data label / ' * x3',' * y3',' * x2y',' * y2x',' * x2',' * y2',
c     1' * xy',' * x',' * y',' dc' /
      ierr=0
      nall=nc*nr
      ifact=sqrt(float(4*nall/maxcol))+2
      sum=0.0
      num=0
      k=0
      do 2000 j=1,nr,ifact
      y=(-nr/2+j)*dy
c      read(in1,rec=j) (z(i),i = 1, nc)
      call GetRow_WF(in1,j,nc,z,ierr)
      do 1000 i=1,nc,ifact
      x=(-nc/2+i)*dx
      if(z(i).ne.dummy) then
        k=k+1
        if(iorder.eq.0) then
          sum=sum+z(i)
        else if(iorder.eq.1) then
          a(k,1)=x
          a(k,2)=y
          a(k,3)=1.0
          b(k)=z(i)
        else if(iorder.eq.2) then
          a(k,1)=x*x
          a(k,2)=y*y
          a(k,3)=x*y
          a(k,4)=x
          a(k,5)=y
          a(k,6)=1.0
          b(k)=z(i)
        else if(iorder.eq.3) then
          a(k,1)=x*x*x
          a(k,2)=y*y*y
          a(k,3)=x*x*y
          a(k,4)=x*y*y
          a(k,5)=x*x
          a(k,6)=y*y
          a(k,7)=x*y
          a(k,8)=x
          a(k,9)=y
          a(k,10)=1.0
          b(k)=z(i)
        endif
      endif
 1000 continue
 2000 continue
      if(iorder.eq.0) then
        sum=sum/k
      else if(iorder.eq.1) then
        call golub(a,c,b,u,maxcol/4,k,3)
      else if(iorder.eq.2) then
        call golub(a,c,b,u,maxcol/4,k,6)
      else if(iorder.eq.3) then
        call golub(a,c,b,u,maxcol/4,k,10)
      endif
c      print*,c
c      print*,'polynomial coefficients:'
c      if(iorder.eq.0) then
c        print*,sum,' dc'
c      else
c        num=0
c        do i=1,iorder+1
c        num=num+i
c        enddo
cc        print*,(c(i),i=1,num)
c        write(6,100) (c(i),label(10-num+i),i=1,num)
c  100   format(3(1pg16.6,a6),\)
c      endif
      do 4000 j=1,nr
      y=(-nr/2+j)*dy
c      read(in1,rec=j) (z(i),i = 1, nc)
      call GetRow_WF(in1,j,nc,z,ierr)
      do 3000 i=1,nc
      x=(-nc/2+i)*dx
      if(z(i).eq.dummy) then
        if(iorder.eq.0) then
          z(i)=sum
        else if(iorder.eq.1) then
          z(i)=c(1)*x+c(2)*y+c(3)
        else if(iorder.eq.2) then
          z(i)=c(1)*x*x+c(2)*y*y+c(3)*x*y+c(4)*x+c(5)*y+c(6)
        else if(iorder.eq.3) then
          z(i)=c(1)*x*x*x+c(2)*y*y*y+c(3)*x*x*y+c(4)*x*y*y+
     1         c(5)*x*x+c(6)*y*y+c(7)*x*y+c(8)*x+c(9)*y+c(10)
        endif
      endif
 3000 continue
c      write(in1,rec=j) (z(i),i = 1, nc)
      call PutRow_WF(in1,j,nc,z,ierr)
      call ProgUpdateL_WF(j,NR)
      call CheckStop_WF(ierr)
            if(ierr.eq.1) goto 9999
 4000 continue
 9999 return
      end
c
      subroutine golub(a,x,b,u,mdim,m,n)
c
c  solution of a(m,n) * x(n) = b(m), m > n, m < 1001
c  standard errors for x(1-n) are returned in b(1-n)
c
      implicit double precision (d)
      real a(mdim,n),x(n),b(m),u(m)
c upper triangularize matrix a
      do 3010 k=1,n
      dsum=0.0d0
      do 1010 i=k,m
      daj=a(i,k)
 1010 dsum=dsum+daj**2
      dai=a(k,k)
c      dsigma=dsign(dsqrt(dsum),dai)
      if(dai.ge.0.0d0) then
         dsigma=dabs(dsqrt(dsum))
      else
         dsigma=-dabs(dsqrt(dsum))
      endif
      dbi=dsqrt(1.0d0+dai/dsigma)
      dfact=1.0d0/(dsigma*dbi)
      u(k)=dbi
      fact=dfact
      kplus=k+1
      do 1020 i=kplus,m
 1020 u(i)=fact*a(i,k)
      do 2030 j=k,n
      fact=0.0
      do 2010 i=k,m
 2010 fact=fact+u(i)*a(i,j)
      do 2020 i=k,m
 2020 a(i,j)=a(i,j)-fact*u(i)
 2030 continue
      fact=0.0
      do 2040 i=k,m
 2040 fact=fact+u(i)*b(i)
      do 2050 i=k,m
 2050 b(i)=b(i)-fact*u(i)
 3010 continue
c     back substitute to get solution x
      x(n)=b(n)/a(n,n)
      lim=n-1
      do 4020 i=1,lim
      irow=n-i
      sum=0.0
      do 4010 j=1,i
 4010 sum=sum+x(n-j+1)*a(irow,n-j+1)
 4020 x(irow)=(b(irow)-sum)/a(irow,irow)
      return
      end
