c  usgs_prep4.f
c
c  Extends a grid to reduce FFT wraparound.
c  Undo the extension with program de_prep4.
c
c  prep:  Lin Cordell Jan 1990.
c         Revised June 1991.
c  prep3: Jeff Phillips February 1996
c  prep4: Jeff Phillips August 1999  added centering and min,max limits
c         Jeff Phillips January 2000  modified for use in a Geosoft GX
c
      subroutine prep4(ifile,ofile,pct,ierr)
      parameter (maxcol=16384)
      character*(*) ifile,ofile
      integer*4 inunit,outunit,scrunit,dumunit,ierr
      dimension ncnr(2)
      common /extreme/ gmin,gmax
      data inunit/0/,outunit/0/,scrunit/0/,dumunit/0/
      call OpenGrid_WF(ifile,inunit,ierr)
      if(ierr.ne.0) go to 9999
c
      call GetGridInfo_WF(inunit,nc,nr,xo,yo,dx,dy,rot,ierr)
      if(ierr.ne.0) go to 9999
        if(nc.lt.15) go to 9999
        if(nr.lt.15) go to 9999
c
      if(nc.gt.maxcol) then
        call RegisterErr_WF(1000, 'usgs')
        call SetErrParmI_WF(1,nc)
        call SetErrParmI_WF(2,maxcol)
        ierr=1
        go to 9999
      endif
      if(nr.gt.maxcol) then
        call RegisterErr_WF(1001, 'usgs')
        call SetErrParmI_WF(1,nr)
        call SetErrParmI_WF(2,maxcol)
        ierr=1
        go to 9999
      endif

      call ProgName_WF('Step 1 of 8 -- Get min/max grid values',1)
      call ProgUpdate_WF(0)
c  Get min, max
      call check(inunit,nc,nr,ierr)
      if(ierr.ne.0) go to 9999
     
c  Set FFT dimensions
        call fftdims(nc,nr,pct,ncnr(1),ncnr(2))
        ncol=ncnr(1)
        nrow=ncnr(2)
      if(nc.gt.ncol.or.nr.gt.nrow) go to 9999

      if(ncol.gt.maxcol) then
        call RegisterErr_WF(1002, 'usgs')
        call SetErrParmI_WF(1,ncol)
        call SetErrParmI_WF(2,maxcol)
        ierr=1
        go to 9999
      endif
      if(nrow.gt.maxcol) then
        call RegisterErr_WF(1003, 'usgs')
        call SetErrParmI_WF(1,nrow)
        call SetErrParmI_WF(2,maxcol)
        ierr=1
        go to 9999
      endif

      call ProgName_WF('Step 2 of 8 -- Extend rows',1)
c
      call NewGrid_WF(scrunit,'scratch.tmp',ncol,nr,xo,yo,dx,dy,rot,
     1ierr)
      if(ierr.ne.0) go to 9999
c  extend grid to right
      call extend(inunit,scrunit,nc,nr,nr,ncol,ierr)
      if(ierr.ne.0) go to 9999
      call CloseGrid_WF(inunit,ierr)
      if(ierr.ne.0) go to 9999
 
c  transpose grid
c
      call CloseGrid_WF(scrunit,ierr)
      if(ierr.ne.0) go to 9999
      call OpenGrid_WF('scratch.tmp',scrunit,ierr)
      if(ierr.ne.0) go to 9999
c
      call NewGrid_WF(dumunit,'dummy.tmp',nr,ncol,yo,xo,dy,dx,rot,ierr)
      if(ierr.ne.0) go to 9999
      call ProgName_WF('Step 3 of 8 -- Transpose extended grid',1)
      call transpos(scrunit,dumunit,ierr)
      if(ierr.ne.0) go to 9999
      call CloseGrid_WF(scrunit,ierr)
      if(ierr.ne.0) go to 9999

      call ProgName_WF('Step 4 of 8 -- Extend columns',1)
c
c The following should not be necessary, but is a work-around for a bug
c in CloseGrid_WF
c
      call CloseGrid_WF(dumunit,ierr)
      if(ierr.ne.0) go to 9999
      call OpenGrid_WF('dummy.tmp',dumunit,ierr)
      if(ierr.ne.0) go to 9999
c
      call NewGrid_WF(scrunit,'scratch.tmp',nrow,ncol,yo,xo,dy,dx,rot,
     1ierr)
      if(ierr.ne.0) go to 9999
c  extend grid to top
      call extend(dumunit,scrunit,nr,ncol,nc,nrow,ierr)
      if(ierr.ne.0) go to 9999
      call CloseGrid_WF(dumunit,ierr)
      if(ierr.ne.0) go to 9999

      call ProgName_WF('Step 5 of 8 -- Smooth first extension',1)
c  smooth first extension
c
c The following should not be necessary, but is a work-around for a bug
c in CloseGrid_WF
c
      call CloseGrid_WF(scrunit,ierr)
      if(ierr.ne.0) go to 9999
      call OpenGrid_WF('scratch.tmp',scrunit,ierr)
      if(ierr.ne.0) go to 9999
c
      call NewGrid_WF(dumunit,'dummy.tmp',nrow,ncol,yo,xo,dy,dx,rot,
     1ierr)
      if(ierr.ne.0) go to 9999
      call smooth(scrunit,dumunit,nc,ierr)
      if(ierr.ne.0) go to 9999
      call CloseGrid_WF(scrunit,ierr)
      if(ierr.ne.0) go to 9999

c  transpose back
c
      call CloseGrid_WF(dumunit,ierr)
      if(ierr.ne.0) go to 9999
      call OpenGrid_WF('dummy.tmp',dumunit,ierr)
      if(ierr.ne.0) go to 9999
c
      call NewGrid_WF(scrunit,'scratch.tmp',ncol,nrow,xo,yo,dx,dy,rot,
     1ierr)
      if(ierr.ne.0) go to 9999
      call ProgName_WF('Step 6 of 8 -- Transpose back',1)
      call transpos(dumunit,scrunit,ierr)
      if(ierr.ne.0) go to 9999
      call CloseGrid_WF(dumunit,ierr)
      if(ierr.ne.0) go to 9999

      call ProgName_WF('Step 7 of 8 -- Smooth second extension',1)
c
c  smooth second extension
c
c The following should not be necessary, but is a work-around for a bug
c in CloseGrid_WF
c
      call CloseGrid_WF(scrunit,ierr)
      if(ierr.ne.0) go to 9999
      call OpenGrid_WF('scratch.tmp',scrunit,ierr)
      if(ierr.ne.0) go to 9999
c
      call NewGrid_WF(dumunit,'dummy.tmp',ncol,nrow,xo,yo,dx,dy,rot,
     1ierr)
      if(ierr.ne.0) go to 9999
      call smooth(scrunit,dumunit,nr,ierr)
      if(ierr.ne.0) go to 9999
      call CloseGrid_WF(scrunit,ierr)
      if(ierr.ne.0) go to 9999

      call ProgName_WF('Step 8 of 8 -- Center data',1)
c  centering data
c
c The following should not be necessary, but is a work-around for a bug
c in CloseGrid_WF
c
      call CloseGrid_WF(dumunit,ierr)
      if(ierr.ne.0) go to 9999
      call OpenGrid_WF('dummy.tmp',dumunit,ierr)
      if(ierr.ne.0) go to 9999
c
        nx=(ncol-nc)/2
        ny=(nrow-nr)/2
        xo=xo-nx*dx
        yo=yo-ny*dy
c
      call NewGrid_WF(outunit,ofile,ncol,nrow,xo,yo,dx,dy,rot,ierr)
      if(ierr.ne.0) go to 9999
      call center(dumunit,outunit,nc,nr,ierr)
      if(ierr.ne.0) go to 9999
      call CloseGrid_WF(dumunit,ierr)
      if(ierr.ne.0) go to 9999
      call CloseGrid_WF(outunit,ierr)
      if(ierr.ne.0) go to 9999

 9999 return
      end
c **************************************************************
      subroutine fftdims(ncol, nrow, pct, ncout, nrout)
c
c     suggests new dimensions for fourier transform
c
c     Jeff Phillips 2000
c
      dimension nlist(46)
      data nlist /4,6,8,10,12,14,16,18,20,24,28,
     &30,36,40,42,48,56,60,70,72,80,84,90,112,120,
     &126,140,144,168,180,210,240,252,280,336,360,
     &420,504,560,630,720,840,1008,1260,1680,2520/
c
c test for dimensions that fft2in likes
      if(pct.gt.100.) pct=100.
      ncol2=ncol*(1.+ pct/100.)
      nrow2=nrow*(1.+ pct/100.)
      ncout = 0
      do 10 i = 1, 46
      if (nlist(i) .lt. ncol2) goto 10
      ncout=nlist(i)
      go to 20
   10 continue
      go to 800
   20 continue
      nrout = 0
      do 30 i = 1, 46
      if (nlist(i) .lt. nrow2) goto 30
      nrout=nlist(i)
      return
   30 continue
  800 continue
c  at least one dimension is bigger than 2520; use powers of two.
      i=0
   50 i=i+1
      ntest=2.**float(i)
      if(ncol2.gt.ntest) go to 50
      ncout=ntest
      i=0
   52 i=i+1
      ntest=2.**float(i)
      if(nrow2.gt.ntest) go to 52
      nrout=ntest
   53 return
      end
c***********************************************************************
      subroutine extend(in,io,nc,nr,nrow,ncol,ierr)
c extend grid to the right using prediction filters
c   in:   input unit number
c   io:   output unit number
c   nc:   columns in input grid
c   nr:   rows in input grid
c   nrow: last row to be used in designing the prediction filter
c   ncol: columns in the extended grid
      parameter (maxcol=16384)
      dimension we(16),wesav(16)
      dimension g(maxcol)
      ierr=0
      inc=(nrow+nr)/50
        do 11 i=1,16
   11   wesav(i)=0.
c  Rows down to nrow.
        do 204 j2=1,nrow
      call GetRow_WF(in,j2,nc,g,ierr)
      if(ierr.ne.0) go to 9999
      call predfilt(nc,ncol,g,16,we)
        do 12 i=1,16
   12   wesav(i)=wesav(i)+we(i)
      if(mod(j2,inc).eq.0) then
        call ProgUpdateL_WF(j2,nrow+nr)
        call CheckStop_WF(ierr)
        if(ierr.ne.0) go to 9999
      endif
204     continue
      do 13 i=1,16
   13 wesav(i)=wesav(i)/float(nrow)
      do 14 j=1,nr
      call GetRow_WF(in,j,nc,g,ierr)
      if(ierr.ne.0) go to 9999
      call filter(nc,ncol,g,16,wesav)
      call PutRow_WF(io,j,ncol,g,ierr)
      if(ierr.ne.0) go to 9999
      if(mod(nrow+j,inc).eq.0) then
        call ProgUpdateL_WF(nrow+j,nrow+nr)
        call CheckStop_WF(ierr)
        if(ierr.ne.0) go to 9999
      endif
   14 continue
 9999 return
      end
c *****************************
c *****************************
      subroutine predfilt(n,lc,a,nco,we)
c determine prediction filter coefs we from profile a
      parameter (maxcol=16384)
      dimension a(lc),we(nco)
      dimension aa(maxcol),v(maxcol)
      real*8 ap,xind
      common /extreme/ gmin,gmax
        pi=3.1415927
      if(lc.gt.maxcol) go to 9999
      do 20 i=1,n
      aa(i)=a(i)
   20 v(i)=a(i)
      we(1)=1.
      do 23 j=2,nco
      ap=0.
      xind=0.
      do 21 i=j,n
      ap=ap+aa(i)*aa(i)+v(i-j+1)*v(i-j+1)
   21 xind=xind+aa(i)*v(i-j+1)
c      if(ap.eq.0.) stop 'error: ap=0'
      if(ap.eq.0.) then
        rc=0.
      else
        rc=-2.*xind/ap
      endif
      do 22 i=j,n
      temp=aa(i)
      aa(i)=aa(i)+rc*v(i-j+1)
   22 v(i-j+1)=v(i-j+1)+rc*temp
      we(j)=0.
      jh=(j+1)/2
      do 23 i=1,jh
      k=j-i+1
      temp=we(k)+rc*we(i)
      we(i)=we(i)+rc*we(k)
   23 we(k)=temp
 9999 return
c *****************************
      entry filter(n,lc,a,nco,we)
c extend profile
      lp=n+1
      do 27 i=1,n
   27 aa(i)=a(n-i+1)
      do 28 i=lp,lc
      a(i)=0.
      aa(i)=0.
      do 28 j=2,nco
      a(i)=a(i)-we(j)*a(i-j+1)
   28 aa(i)=aa(i)-we(j)*aa(i-j+1)
      do 29 i=lp,lc
      w=pi*float(i-lp)/float(lc-lp)
      w=(cos(w)+1.)/2.
      a(i)=w*a(i)+(1.-w)*aa(lc-i+lp)
      if(a(i).lt.gmin) a(i)=gmin
      if(a(i).gt.gmax) a(i)=gmax
   29 continue
      return
      end
c *****************************
      subroutine transpos(in,io,ierr)
      parameter (maxcol=16384)
      dimension col(maxcol)
      ierr=0
      call GetGridInfo_WF(in,nc,nr,xo,yo,dx,dy,rot,ierr)
      if(ierr.ne.0) go to 9999
      inc=nc/50
      do 10 j=1,nc
      call GetCol_WF(in,j,nr,col,ierr)
      if(ierr.ne.0) go to 9999
      call PutRow_WF(io,j,nr,col,ierr)
      if(ierr.ne.0) go to 9999
      if(mod(j,inc).eq.0) then
        call ProgUpdateL_WF(j,nc)
        call CheckStop_WF(ierr)
        if(ierr.ne.0) go to 9999
      endif
   10 continue
 9999 return
      end
c *****************************
      subroutine smooth(in,io,nr,ierr)
c smooth across rows
c   in:   input unit number
c   io:   output unit number
c   nr:   number of rows to skip
      parameter (maxcol=16384)
      dimension g(maxcol),h(maxcol)
      ierr=0
      call GetGridInfo_WF(in,nc,nrow,xo,yo,dx,dy,rot,ierr)
      if(ierr.ne.0) go to 9999
      inc=nrow/50
      do 10 j=1,nr
      call GetRow_WF(in,j,nc,g,ierr)
      if(ierr.ne.0) go to 9999
      call PutRow_WF(io,j,nc,g,ierr)
      if(ierr.ne.0) go to 9999
      if(mod(j,inc).eq.0) then
        call ProgUpdateL_WF(j,nrow)
        call CheckStop_WF(ierr)
        if(ierr.ne.0) go to 9999
      endif
  10  continue
      do 30 j=nr+1,nrow
      call GetRow_WF(in,j,nc,g,ierr)
      if(ierr.ne.0) go to 9999
      k=min0(j-nr,nrow-j+1)
      do 20 i=1,k
      h(i)=g(i)
      do 19 ii=1,k
      kk=mod(nc+i-ii,nc)
      if(kk.eq.0) kk=nc
   19 h(i)=h(i)+(k-ii+1)*(g(i+ii)+g(kk))/float(k+1)
   20 h(i)=h(i)/float(k+1)
c
      do 22 i=k+1,nc-k
      h(i)=g(i)
      do 21 ii=1,k
  21  h(i)=h(i)+(k-ii+1)*(g(i+ii)+g(i-ii))/float(k+1)
  22  h(i)=h(i)/float(k+1)
c
      do 25 i=nc-k+1,nc
      h(i)=g(i)
      do 24 ii=1,k
      kk=mod(i+ii,nc)
      if(kk.eq.0) kk=nc
   24 h(i)=h(i)+(k-ii+1)*(g(i-ii)+g(kk))/float(k+1)
   25 h(i)=h(i)/float(k+1)

      call PutRow_WF(io,j,nc,h,ierr)
      if(ierr.ne.0) go to 9999
      if(mod(j,inc).eq.0) then
        call ProgUpdateL_WF(j,nrow)
        call CheckStop_WF(ierr)
        if(ierr.ne.0) go to 9999
      endif
   30 continue
 9999 return
      end
c *****************************
      subroutine center(in,io,nc,nr,ierr)
c smooth across rows
c   in:   input unit number
c   io:   output unit number
c   nc:   original number of columns
c   nr:   original number of rows
      parameter (maxcol=16384)
      dimension g(maxcol)
      ierr=0
      call GetGridInfo_WF(in,ncol,nrow,xo,yo,dx,dy,rot,ierr)
      if(ierr.ne.0) go to 9999
      inc=nrow/50
        nx=(ncol-nc)/2
        ny=(nrow-nr)/2
      jw=0
      do 30 j=nrow-ny+1,nrow
      jw=jw+1
      call GetRow_WF(in,j,ncol,g,ierr)
      if(ierr.ne.0) go to 9999
        do 25 k=1,nx
        temp=g(ncol)
        do 20 i=ncol,2,-1
        g(i)=g(i-1)
  20  continue
        g(1)=temp
  25  continue
      call PutRow_WF(io,jw,ncol,g,ierr)
      if(ierr.ne.0) go to 9999
      if(mod(jw,inc).eq.0) then
        call ProgUpdateL_WF(jw,nrow)
        call CheckStop_WF(ierr)
        if(ierr.ne.0) go to 9999
      endif
  30  continue
      do 50 j=1,nrow-ny
      jw=jw+1
      call GetRow_WF(in,j,ncol,g,ierr)
      if(ierr.ne.0) go to 9999
        do 45 k=1,nx
        temp=g(ncol)
        do 40 i=ncol,2,-1
        g(i)=g(i-1)
  40  continue
        g(1)=temp
  45  continue
      call PutRow_WF(io,jw,ncol,g,ierr)
      if(ierr.ne.0) go to 9999
      if(mod(jw,inc).eq.0) then
        call ProgUpdateL_WF(jw,nrow)
        call CheckStop_WF(ierr)
        if(ierr.ne.0) go to 9999
      endif
  50  continue
 9999 return
      end
c *****************************
      subroutine check(in,nc,nr,ierr)
      parameter (maxcol=16384)
      dimension g(maxcol)
      common /extreme/ gmin,gmax
      ierr=0
      gmin=1.e38
      gmax=-1.e38
      inc=nr/50
      j=1
      call GetRow_WF(in,j,nc,g,ierr)
      if(ierr.ne.0) go to 9999
      do 10 i=1,nc
      if(g(i).lt.gmin) gmin=g(i)
      if(g(i).gt.gmax) gmax=g(i)
   10 continue
      do 30 j=2,nr-1
      call GetRow_WF(in,j,nc,g,ierr)
      if(ierr.ne.0) go to 9999
      do 20 i=1,nc
   20 continue
      if(g(1).lt.gmin) gmin=g(1)
      if(g(1).gt.gmax) gmax=g(1)
      if(g(nc).lt.gmin) gmin=g(nc)
      if(g(nc).gt.gmax) gmax=g(nc)
      if(mod(j,inc).eq.0) then
        call ProgUpdateL_WF(j-1,nr)
        call CheckStop_WF(ierr)
        if(ierr.ne.0) go to 9999
      endif
   30 continue
      j=nr
      call GetRow_WF(in,j,nc,g,ierr)
      if(ierr.ne.0) go to 9999
      do 40 i=1,nc
      if(g(i).lt.gmin) gmin=g(i)
      if(g(i).gt.gmax) gmax=g(i)
   40 continue
 9999 return
      end
